class AcidSynthWrapper(Module):
  __parameters__ = []
  __buffers__ = ["default_param_values", ]
  default_param_values : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  MAX_N_PARAMS : int
  SDK_VERSION : str
  CURRENT_TIME : float
  use_debug_mode : bool
  n_neutone_parameters : int
  neutone_parameters_metadata : Dict[str, Dict[str, str]]
  remapped_params : Dict[str, Tensor]
  neutone_parameter_names : List[str]
  neutone_parameter_descriptions : List[str]
  neutone_parameter_used : List[bool]
  neutone_parameter_types : List[str]
  in_n_ch : int
  curr_bs : int
  in_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  params_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  model_in_buffer : Tensor
  params_buffer : Tensor
  agg_params : Tensor
  model : __torch__.AcidSynth
  def forward(self: __torch__.AcidSynthWrapper,
    x: Tensor,
    params: Optional[Tensor]=None) -> Tensor:
    _0 = __torch__.neutone_sdk.utils.validate_waveform
    _1 = "Invalid model input audio length of {} samples, must be of length {} samples"
    _2 = "The model does not support a buffer size of {}"
    _3 = "AssertionError: Model uses a look-behind buffer, but the incoming buffer size has not been set. Be sure to call `set_sample_rate_and_buffer_size` before using the model."
    _4 = "Invalid model output audio length of {} samples, must be of length {} samples (are you using a look behind buffer incorrectly?)"
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _5 = _0(x, (self).is_input_mono(), )
    else:
      pass
    in_n = torch.size(x, 1)
    if torch.__is__(params, None):
      params1 = torch.repeat((self).get_default_param_values(), [1, in_n])
      params0 = params1
    else:
      params0 = unchecked_cast(Tensor, params)
    use_debug_mode0 = self.use_debug_mode
    if use_debug_mode0:
      _6 = torch.size(params0)
      MAX_N_PARAMS = self.MAX_N_PARAMS
      _7 = torch.eq(_6, [MAX_N_PARAMS, in_n])
      if _7:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      curr_bs = self.curr_bs
      if torch.ne(curr_bs, -1):
        curr_bs0 = self.curr_bs
        if torch.eq(in_n, curr_bs0):
          pass
        else:
          curr_bs1 = self.curr_bs
          _8 = torch.format(_1, in_n, curr_bs1)
          _9 = torch.add("AssertionError: ", _8)
          ops.prim.RaiseException(_9)
      else:
        _10 = (self).get_native_buffer_sizes()
        if torch.gt(torch.len(_10), 0):
          _11 = (self).get_native_buffer_sizes()
          if torch.__contains__(_11, in_n):
            pass
          else:
            _12 = torch.add("AssertionError: ", torch.format(_2, in_n))
            ops.prim.RaiseException(_12)
        else:
          pass
      _13 = bool((self).get_look_behind_samples())
      if _13:
        curr_bs2 = self.curr_bs
        if torch.ne(curr_bs2, -1):
          pass
        else:
          ops.prim.RaiseException(_3)
      else:
        pass
    else:
      pass
    _14 = bool((self).get_look_behind_samples())
    if _14:
      in_queue = self.in_queue
      _15 = (in_queue).push(x, )
      params_queue = self.params_queue
      _16 = (params_queue).push(params0, )
      in_queue0 = self.in_queue
      size = in_queue0.size
      model_in_buffer = self.model_in_buffer
      _17 = torch.slice(torch.slice(model_in_buffer), 1, 0, torch.neg(size))
      _18 = torch.tensor(0, dtype=ops.prim.dtype(_17), device=ops.prim.device(_17))
      _19 = torch.copy_(_17, _18)
      in_queue1 = self.in_queue
      model_in_buffer0 = self.model_in_buffer
      _20 = torch.slice(torch.slice(model_in_buffer0), 1, torch.neg(size))
      _21 = (in_queue1).fill(_20, )
      _22 = (self).get_default_param_values()
      params_buffer = self.params_buffer
      _23 = torch.slice(torch.slice(params_buffer), 1, 0, torch.neg(size))
      _24 = torch.copy_(_23, _22)
      params_queue0 = self.params_queue
      params_buffer0 = self.params_buffer
      _25 = torch.slice(torch.slice(params_buffer0), 1, torch.neg(size))
      _26 = (params_queue0).fill(_25, )
      model_in_buffer1 = self.model_in_buffer
      params2, x0 = self.params_buffer, model_in_buffer1
    else:
      params2, x0 = params0, x
    params3 = (self).aggregate_params(params2, )
    use_debug_mode1 = self.use_debug_mode
    if use_debug_mode1:
      if torch.eq(torch.dim(params3), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _27 = torch.size(params3, 0)
      MAX_N_PARAMS0 = self.MAX_N_PARAMS
      if torch.eq(_27, MAX_N_PARAMS0):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    n_neutone_parameters = self.n_neutone_parameters
    for idx in range(n_neutone_parameters):
      _28 = torch.select(params3, 0, idx)
      remapped_params = self.remapped_params
      neutone_parameter_names = self.neutone_parameter_names
      torch._set_item(remapped_params, neutone_parameter_names[idx], _28)
    remapped_params0 = self.remapped_params
    x1 = (self).do_forward_pass(x0, remapped_params0, )
    use_debug_mode2 = self.use_debug_mode
    if use_debug_mode2:
      _29 = _0(x1, (self).is_output_mono(), )
      curr_bs3 = self.curr_bs
      if torch.eq(curr_bs3, -1):
        _30 = torch.eq(torch.size(x1, 1), in_n)
        if _30:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        _31 = torch.size(x1, 1)
        curr_bs4 = self.curr_bs
        if torch.eq(_31, curr_bs4):
          pass
        else:
          _32 = torch.size(x1, 1)
          curr_bs5 = self.curr_bs
          _33 = torch.format(_4, _32, curr_bs5)
          _34 = torch.add("AssertionError: ", _33)
          ops.prim.RaiseException(_34)
    else:
      pass
    return x1
  def calc_model_delay_samples(self: __torch__.AcidSynthWrapper) -> int:
    return 0
  def get_core_preserved_attributes(self: __torch__.AcidSynthWrapper) -> List[str]:
    _35 = ["model", "get_neutone_parameters_metadata", "get_default_param_values", "get_default_param_names", "get_default_param_descriptions", "get_default_param_types", "get_default_param_used", "get_wet_default_value", "get_dry_default_value", "get_input_gain_default_value", "get_output_gain_default_value", "get_core_preserved_attributes", "to_core_metadata"]
    return _35
  def get_default_param_descriptions(self: __torch__.AcidSynthWrapper) -> List[str]:
    return self.neutone_parameter_descriptions
  def get_default_param_names(self: __torch__.AcidSynthWrapper) -> List[str]:
    return self.neutone_parameter_names
  def get_default_param_types(self: __torch__.AcidSynthWrapper) -> List[str]:
    return self.neutone_parameter_types
  def get_default_param_used(self: __torch__.AcidSynthWrapper) -> List[bool]:
    return self.neutone_parameter_used
  def get_default_param_values(self: __torch__.AcidSynthWrapper) -> Tensor:
    return self.default_param_values
  def get_dry_default_value(self: __torch__.AcidSynthWrapper) -> float:
    return 0.
  def get_input_gain_default_value(self: __torch__.AcidSynthWrapper) -> float:
    return 0.5
  def get_native_buffer_sizes(self: __torch__.AcidSynthWrapper) -> List[int]:
    model = self.model
    use_fs = model.use_fs
    if use_fs:
      _37 = annotate(List[int], [])
      model0 = self.model
      win_len = model0.win_len
      model1 = self.model
      win_len0 = model1.win_len
      _38 = ops.prim.max(torch.add(win_len0, 1), 10000)
      model2 = self.model
      hop_len = model2.hop_len
      _39 = torch.__range_length(win_len, _38, hop_len)
      for _40 in range(_39):
        bs = torch.__derive_index(_40, win_len, hop_len)
        _41 = torch.append(_37, bs)
      _36 = _37
    else:
      _36 = annotate(List[int], [])
    return _36
  def get_native_sample_rates(self: __torch__.AcidSynthWrapper) -> List[int]:
    model = self.model
    sr = model.sr
    return [sr]
  def get_neutone_parameters_metadata(self: __torch__.AcidSynthWrapper) -> Dict[str, Dict[str, str]]:
    return self.neutone_parameters_metadata
  def get_output_gain_default_value(self: __torch__.AcidSynthWrapper) -> float:
    return 0.5
  def get_preserved_attributes(self: __torch__.AcidSynthWrapper) -> List[str]:
    _42 = "set_daw_sample_rate_and_buffer_size"
    preserved_attrs = (self).get_core_preserved_attributes()
    _43 = ["is_input_mono", "is_output_mono", "get_native_sample_rates", "get_native_buffer_sizes", "is_resampling", "calc_model_delay_samples", "set_sample_rate_and_buffer_size", _42, "reset", "get_preserved_attributes", "to_metadata"]
    torch.extend(preserved_attrs, _43)
    return preserved_attrs
  def get_wet_default_value(self: __torch__.AcidSynthWrapper) -> float:
    return 1.
  def is_input_mono(self: __torch__.AcidSynthWrapper) -> bool:
    return True
  def is_output_mono(self: __torch__.AcidSynthWrapper) -> bool:
    return True
  def is_resampling(self: __torch__.AcidSynthWrapper) -> bool:
    return False
  def reset(self: __torch__.AcidSynthWrapper) -> bool:
    in_queue = self.in_queue
    _44 = (in_queue).reset()
    params_queue = self.params_queue
    _45 = (params_queue).reset()
    model_in_buffer = self.model_in_buffer
    _46 = torch.fill_(model_in_buffer, 0)
    _47 = (self).get_default_param_values()
    params_buffer = self.params_buffer
    _48 = torch.slice(torch.slice(params_buffer), 1)
    _49 = torch.copy_(_48, _47)
    return (self).reset_model()
  def reset_model(self: __torch__.AcidSynthWrapper) -> bool:
    model = self.model
    _50 = (model).reset()
    return True
  def set_daw_sample_rate_and_buffer_size(self: __torch__.AcidSynthWrapper,
    daw_sr: int,
    daw_buffer_size: int,
    model_sr: Optional[int]=None,
    model_buffer_size: Optional[int]=None) -> NoneType:
    _51 = (self).set_sample_rate_and_buffer_size(daw_sr, daw_buffer_size, )
    return None
  def set_sample_rate_and_buffer_size(self: __torch__.AcidSynthWrapper,
    sample_rate: int,
    n_samples: int) -> bool:
    _52 = "The model does not support a native buffer size of {}"
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _53 = torch.len((self).get_native_buffer_sizes())
      if torch.gt(_53, 0):
        _54 = (self).get_native_buffer_sizes()
        _55 = torch.__contains__(_54, n_samples)
        if _55:
          pass
        else:
          _56 = torch.add("AssertionError: ", torch.format(_52, n_samples))
          ops.prim.RaiseException(_56)
      else:
        pass
    else:
      pass
    _57 = bool((self).get_look_behind_samples())
    if _57:
      curr_bs = self.curr_bs
      if torch.eq(curr_bs, -1):
        _58 = True
      else:
        curr_bs6 = self.curr_bs
        _58 = torch.ne(n_samples, curr_bs6)
      if _58:
        self.curr_bs = n_samples
        _59 = (self).get_look_behind_samples()
        curr_bs7 = self.curr_bs
        queue_len = torch.add(_59, curr_bs7)
        in_n_ch = self.in_n_ch
        use_debug_mode3 = self.use_debug_mode
        _60 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
        _61 = (_60).__init__(in_n_ch, queue_len, use_debug_mode3, )
        self.in_queue = _60
        MAX_N_PARAMS = self.MAX_N_PARAMS
        use_debug_mode4 = self.use_debug_mode
        _62 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
        _63 = (_62).__init__(MAX_N_PARAMS, queue_len, use_debug_mode4, )
        self.params_queue = _62
        in_n_ch0 = self.in_n_ch
        _64 = torch.zeros([in_n_ch0, queue_len])
        self.model_in_buffer = _64
        _65 = (self).get_default_param_values()
        _66 = torch.repeat(_65, [1, queue_len])
        self.params_buffer = _66
      else:
        pass
    else:
      pass
    _67 = (self).set_model_sample_rate_and_buffer_size(sample_rate, n_samples, )
    return _67
  def to_core_metadata(self: __torch__.AcidSynthWrapper) -> __torch__.neutone_sdk.core.CoreMetadata:
    _68 = (self).get_model_name()
    _69 = (self).get_model_authors()
    _70 = (self).get_model_short_description()
    _71 = (self).get_model_long_description()
    _72 = (self).get_neutone_parameters_metadata()
    _73 = (self).get_wet_default_value()
    _74 = (self).get_dry_default_value()
    _75 = (self).get_input_gain_default_value()
    _76 = (self).get_output_gain_default_value()
    _77 = (self).get_technical_description()
    _78 = (self).get_technical_links()
    _79 = (self).get_tags()
    _80 = (self).get_model_version()
    SDK_VERSION = self.SDK_VERSION
    CURRENT_TIME = self.CURRENT_TIME
    _81 = __torch__.neutone_sdk.core.CoreMetadata(_68, _69, _70, _71, _77, _78, _72, _73, _74, _75, _76, _79, _80, SDK_VERSION, CURRENT_TIME, "2.1.2", (self).get_citation(), (self).is_experimental())
    return _81
  def to_metadata(self: __torch__.AcidSynthWrapper) -> __torch__.neutone_sdk.wavform_to_wavform.WaveformToWaveformMetadata:
    core_metadata = (self).to_core_metadata()
    _82 = (core_metadata)[0]
    _83 = (core_metadata)[1]
    _84 = (core_metadata)[2]
    _85 = (core_metadata)[3]
    _86 = (core_metadata)[6]
    _87 = (core_metadata)[7]
    _88 = (core_metadata)[8]
    _89 = (core_metadata)[9]
    _90 = (core_metadata)[10]
    _91 = (core_metadata)[4]
    _92 = (core_metadata)[5]
    _93 = (core_metadata)[11]
    _94 = (core_metadata)[12]
    _95 = (core_metadata)[13]
    _96 = (core_metadata)[15]
    _97 = (core_metadata)[14]
    _98 = (core_metadata)[16]
    _99 = (core_metadata)[17]
    _100 = (self).is_input_mono()
    _101 = (self).is_output_mono()
    if (self).is_input_mono():
      _102 = "mono"
    else:
      _102 = "stereo"
    if (self).is_output_mono():
      _103 = "mono"
    else:
      _103 = "stereo"
    _104 = torch.format("{}-{}", _102, _103)
    _105 = (self).get_native_buffer_sizes()
    _106 = __torch__.neutone_sdk.wavform_to_wavform.WaveformToWaveformMetadata(_82, _83, _94, _84, _85, _91, _92, _93, _98, _99, _86, _87, _88, _89, _90, _100, _101, _104, (self).get_native_sample_rates(), _105, (self).get_look_behind_samples(), _95, _96, _97)
    return _106
  def get_look_behind_samples(self: __torch__.AcidSynthWrapper) -> int:
    return 0
  def aggregate_params(self: __torch__.AcidSynthWrapper,
    params: Tensor) -> Tensor:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      if torch.eq(torch.dim(params), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    agg_params = self.agg_params
    _107 = torch.mean(params, [1], True, out=agg_params)
    return self.agg_params
  def do_forward_pass(self: __torch__.AcidSynthWrapper,
    x: Tensor,
    params: Dict[str, Tensor]) -> Tensor:
    n_samples = torch.size(x, -1)
    midi_f0_0to1 = params["midi_f0"]
    w_mod_sig = torch.unsqueeze(params["w_mod_sig"], 0)
    q_mod_sig = torch.unsqueeze(params["q_mod_sig"], 0)
    w_mod_sig0 = torch.expand(w_mod_sig, [-1, n_samples])
    q_mod_sig0 = torch.expand(q_mod_sig, [-1, n_samples])
    alpha_0to1 = params["alpha"]
    x2 = torch.unsqueeze(x, 1)
    model = self.model
    y = (model).forward(x2, midi_f0_0to1, alpha_0to1, w_mod_sig0, q_mod_sig0, )
    return torch.squeeze(y, 1)
  def set_model_sample_rate_and_buffer_size(self: __torch__.AcidSynthWrapper,
    sample_rate: int,
    n_samples: int) -> bool:
    return False
  def get_model_name(self: __torch__.AcidSynthWrapper) -> str:
    model = self.model
    use_fs = model.use_fs
    if use_fs:
      model3 = self.model
      win_len = model3.win_len
      _109 = torch.format("acid_synth_lp_fs_{}", win_len)
      _108 = _109
    else:
      _108 = "acid_synth_lp_td"
    return _108
  def get_model_authors(self: __torch__.AcidSynthWrapper) -> List[str]:
    return ["Christopher Mitcheltree"]
  def get_model_short_description(self: __torch__.AcidSynthWrapper) -> str:
    _110 = "Low-pass biquad TB-303 DDSP implementation."
    return _110
  def get_model_long_description(self: __torch__.AcidSynthWrapper) -> str:
    _111 = "Low-pass biquad TB-303 DDSP implementation for \'Differentiable All-pole Filters for Time-varying Audio Systems\'."
    return _111
  def get_technical_description(self: __torch__.AcidSynthWrapper) -> str:
    _112 = "Wrapper for a TB-303 DDSP implementation consisting of a sawtooth or square wave oscillator, time-varying low-pass biquad filter, and hyperbolic tangent distortion."
    return _112
  def get_technical_links(self: __torch__.AcidSynthWrapper) -> Dict[str, str]:
    _113 = {"Code": "https://github.com/DiffAPF/TB-303"}
    return _113
  def get_tags(self: __torch__.AcidSynthWrapper) -> List[str]:
    _114 = ["subtractive synth", "acid", "TB-303"]
    return _114
  def get_model_version(self: __torch__.AcidSynthWrapper) -> str:
    return "1.0.0"
  def get_citation(self: __torch__.AcidSynthWrapper) -> str:
    return ""
  def is_experimental(self: __torch__.AcidSynthWrapper) -> bool:
    return True
class AcidSynth(Module):
  __parameters__ = []
  __buffers__ = ["note_on_duration", "osc_shape", "osc_gain", "dist_gain", "phase", "zi", ]
  note_on_duration : Tensor
  osc_shape : Tensor
  osc_gain : Tensor
  dist_gain : Tensor
  phase : Tensor
  zi : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  ac : __torch__.audio_config.AudioConfig
  min_midi_f0 : int
  max_midi_f0 : int
  min_alpha : float
  max_alpha : float
  min_w_hz : float
  max_w_hz : float
  min_q : float
  max_q : float
  sr : int
  use_fs : bool
  win_len : int
  overlap : float
  hop_len : int
  oversampling_factor : int
  note_on_samples : int
  curr_env_val : float
  midi_f0_to_hz : Dict[int, Tensor]
  synth : __torch__.synths.AcidSynthLPBiquadFSM
  def forward(self: __torch__.AcidSynth,
    x: Tensor,
    midi_f0_0to1: Tensor,
    alpha_0to1: Tensor,
    w_mod_sig: Tensor,
    q_mod_sig: Tensor) -> Tensor:
    n_samples = torch.size(x, -1)
    max_alpha = self.max_alpha
    min_alpha = self.min_alpha
    _115 = torch.mul(alpha_0to1, torch.sub(max_alpha, min_alpha))
    min_alpha0 = self.min_alpha
    alpha = torch.add(_115, min_alpha0)
    note_on_samples = self.note_on_samples
    curr_env_val = self.curr_env_val
    _116 = __torch__.make_envelope(x, note_on_samples, curr_env_val, )
    env, _117, new_env_val, = _116
    self.curr_env_val = new_env_val
    if bool(torch.ne(alpha, 1.)):
      _118 = torch.pow(env, alpha, out=env)
    else:
      pass
    max_midi_f0 = self.max_midi_f0
    min_midi_f0 = self.min_midi_f0
    _119 = torch.mul(midi_f0_0to1, torch.sub(max_midi_f0, min_midi_f0))
    min_midi_f00 = self.min_midi_f0
    midi_f0 = torch.add(_119, min_midi_f00)
    midi_f00 = torch.item(torch.to(torch.round(midi_f0), 3))
    midi_f0_to_hz = self.midi_f0_to_hz
    f0_hz = midi_f0_to_hz[int(midi_f00)]
    zi = self.zi
    filter_args = {"w_mod_sig": w_mod_sig, "q_mod_sig": q_mod_sig, "zi": zi}
    osc_shape = self.osc_shape
    osc_gain = self.osc_gain
    dist_gain = self.dist_gain
    global_params = {"osc_shape": osc_shape, "osc_gain": osc_gain, "dist_gain": dist_gain, "learned_alpha": alpha}
    synth = self.synth
    note_on_duration = self.note_on_duration
    phase = self.phase
    synth_out = (synth).forward(n_samples, f0_hz, note_on_duration, phase, filter_args, global_params, env, )
    wet = synth_out["wet"]
    sr = self.sr
    _120 = torch.reciprocal(torch.to(f0_hz, 7))
    _121 = torch.reciprocal(torch.mul(_120, sr))
    period_completion = torch.remainder(torch.mul(_121, n_samples), 1.)
    phase0 = self.phase
    _122 = torch.mul(period_completion, 6.2831853071795862)
    phase1 = self.phase
    _123 = torch.add(phase0, _122, out=phase1)
    use_fs = self.use_fs
    if torch.__not__(use_fs):
      y_a = synth_out["y_a"]
      _124 = torch.slice(torch.slice(y_a), 1, -2)
      zi0 = self.zi
      _125 = torch.copy_(torch.slice(torch.slice(zi0), 1), _124)
    else:
      pass
    return wet
  def reset(self: __torch__.AcidSynth) -> NoneType:
    self.curr_env_val = 1.
    phase = self.phase
    _126 = torch.zero_(phase)
    zi = self.zi
    _127 = torch.zero_(zi)
    return None
def make_envelope(x: Tensor,
    note_on_samples: int,
    curr_env_val: float) -> Tuple[Tensor, int, float]:
  n_samples = torch.size(x, -1)
  n_env = torch.floordiv(torch.mul(2, n_samples), note_on_samples)
  n_env0 = ops.prim.max(n_env, 2)
  env = torch.linspace(1., 0., note_on_samples)
  env0 = torch.repeat(env, [n_env0])
  out = torch.zeros([1, n_samples])
  non_zero_indices = torch.nonzero(torch.squeeze(x))
  _128 = torch.gt(torch.size(non_zero_indices, 0), 0)
  if _128:
    _129 = torch.select(non_zero_indices, 0, 0)
    first_nonzero_idx0 = torch.item(torch.select(_129, 0, 0))
    first_nonzero_idx = int(first_nonzero_idx0)
  else:
    first_nonzero_idx = -1
  if torch.eq(first_nonzero_idx, -1):
    _130 = torch.eq(curr_env_val, 0.)
  else:
    _130 = False
  if _130:
    _131 = (out, 0, curr_env_val)
  else:
    if torch.ne(curr_env_val, 0.):
      _132 = torch.mul(torch.sub(1., curr_env_val), torch.sub(note_on_samples, 1))
      cont_env_start_idx0 = int(torch.round(_132))
      cont_env_start_idx1 = ops.prim.min(cont_env_start_idx0, torch.sub(note_on_samples, 1))
      cont_env_start_idx2 = ops.prim.max(cont_env_start_idx1, 0)
      cont_env_start_idx = cont_env_start_idx2
    else:
      cont_env_start_idx = 0
    if torch.eq(first_nonzero_idx, 0):
      _134 = torch.add(cont_env_start_idx, n_samples)
      _135 = torch.slice(env0, 0, cont_env_start_idx, _134)
      _136 = torch.slice(torch.slice(out), 1, 0, n_samples)
      _137 = torch.copy_(_136, _135)
      _138 = torch.select(torch.select(out, 0, 0), 0, -1)
      curr_env_val0 = torch.item(_138)
      _139 = (out, first_nonzero_idx, float(curr_env_val0))
      _133 = _139
    else:
      if torch.ne(curr_env_val, 0.):
        _140 = torch.sub(note_on_samples, cont_env_start_idx)
        cont_env_len0 = ops.prim.min(n_samples, _140)
        cont_env_end_idx = torch.add(cont_env_start_idx, cont_env_len0)
        _141 = torch.slice(env0, 0, cont_env_start_idx, cont_env_end_idx)
        _142 = torch.slice(torch.slice(out), 1, 0, cont_env_len0)
        _143 = torch.copy_(_142, _141)
        cont_env_len = cont_env_len0
      else:
        cont_env_len = 0
      if torch.eq(first_nonzero_idx, -1):
        _145 = torch.select(torch.select(out, 0, 0), 0, -1)
        curr_env_val1 = torch.item(_145)
        _144 = (out, 0, float(curr_env_val1))
      else:
        first_nonzero_idx1 = ops.prim.max(first_nonzero_idx, cont_env_len)
        n_non_zero_samples = torch.sub(n_samples, first_nonzero_idx1)
        _146 = torch.slice(env0, 0, 0, n_non_zero_samples)
        _147 = torch.slice(torch.slice(out), 1, first_nonzero_idx1, n_samples)
        _148 = torch.copy_(_147, _146)
        _149 = torch.select(torch.select(out, 0, 0), 0, -1)
        curr_env_val2 = torch.item(_149)
        _150 = (out, first_nonzero_idx1, float(curr_env_val2))
        _144 = _150
      _133 = _144
    _131 = _133
  return _131
