def interpolate(input: Tensor,
    size: Optional[int]=None,
    scale_factor: Optional[List[float]]=None,
    mode: str="nearest",
    align_corners: Optional[bool]=None,
    recompute_scale_factor: Optional[bool]=None,
    antialias: bool=False) -> Tensor:
  _0 = "align_corners option can only be set with the interpolating modes: linear | bilinear | bicubic | trilinear"
  _1 = "only one of size or scale_factor should be defined"
  _2 = "Input and scale_factor must have the same number of spatial dimensions, but got input with spatial dimensions of {} and scale_factor of shape {}. Please provide input tensor in (N, C, d1, d2, ...,dK) format and scale_factor in (s1, s2, ...,sK) format."
  _3 = "either size or scale_factor should be defined"
  _4 = "recompute_scale_factor is not meaningful with an explicit size."
  _5 = "Anti-alias option is only supported for bilinear and bicubic modes"
  _6 = __torch__.torch.nn.functional.adaptive_avg_pool2d
  _7 = __torch__.torch.nn.functional.adaptive_avg_pool3d
  _8 = "Got 3D input, but bilinear mode needs 4D input"
  _9 = "Got 3D input, but trilinear mode needs 5D input"
  _10 = "Got 4D input, but linear mode needs 3D input"
  _11 = "Got 4D input, but trilinear mode needs 5D input"
  _12 = "Got 5D input, but linear mode needs 3D input"
  _13 = "Got 5D input, but bilinear mode needs 4D input"
  _14 = "Input Error: Only 3D, 4D and 5D input Tensors supported (got {}D) for the modes: nearest | linear | bilinear | bicubic | trilinear | area | nearest-exact (got {})"
  _15 = uninitialized(Tensor)
  _16 = uninitialized(List[int])
  _17 = uninitialized(Optional[bool])
  _18 = uninitialized(NoneType)
  _19 = uninitialized(List[float])
  _20 = uninitialized(Optional[List[int]])
  _21 = uninitialized(Optional[List[float]])
  _22 = uninitialized(Optional[int])
  _23 = uninitialized(Optional[bool])
  _24 = uninitialized(bool)
  _25 = torch.__contains__(["nearest", "area", "nearest-exact"], mode)
  if _25:
    _26 = torch.__isnot__(align_corners, None)
    if _26:
      ops.prim.RaiseException(_0, "builtins.ValueError")
      align_corners1 : Optional[bool] = _23
    else:
      align_corners1 = align_corners
    align_corners0 : Optional[bool] = align_corners1
  else:
    if torch.__is__(align_corners, None):
      align_corners2 = False
    else:
      align_corners3 = unchecked_cast(bool, align_corners)
      align_corners2 = align_corners3
    align_corners0 = align_corners2
  dim = torch.sub(torch.dim(input), 2)
  if torch.__isnot__(size, None):
    size1 = unchecked_cast(int, size)
    _27, size0 = torch.__isnot__(scale_factor, None), size1
  else:
    _27, size0 = False, size
  if _27:
    ops.prim.RaiseException(_1, "builtins.ValueError")
    size2, output_size, scale_factors = _22, _20, _21
  else:
    if torch.__isnot__(size0, None):
      size4 = unchecked_cast(int, size0)
      if torch.__is__(scale_factor, None):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      size5 = unchecked_cast(int, size4)
      output_size1 = annotate(List[int], [])
      for _28 in range(dim):
        _29 = torch.append(output_size1, size5)
      size3, output_size0, scale_factors0 = size5, output_size1, None
    else:
      _30 = torch.__isnot__(scale_factor, None)
      if _30:
        scale_factor0 = unchecked_cast(List[float], scale_factor)
        if torch.__is__(size0, None):
          size7 : Optional[int] = size0
        else:
          ops.prim.RaiseException("AssertionError: ")
          size7 = _22
        scale_factor1 = unchecked_cast(List[float], scale_factor0)
        _31 = torch.ne(torch.len(scale_factor1), dim)
        if _31:
          _32 = torch.slice(torch.size(input), 2)
          _33 = torch.format(_2, torch.list(_32), scale_factor1)
          ops.prim.RaiseException(_33, "builtins.ValueError")
        else:
          pass
        size6, output_size2, scale_factors1 = size7, None, scale_factor1
      else:
        ops.prim.RaiseException(_3, "builtins.ValueError")
        size6, output_size2, scale_factors1 = _22, _18, _19
      size3, output_size0, scale_factors0 = size6, output_size2, scale_factors1
    size2, output_size, scale_factors = size3, output_size0, scale_factors0
  _34 = torch.__isnot__(recompute_scale_factor, None)
  if _34:
    recompute_scale_factor1 = unchecked_cast(bool, recompute_scale_factor)
    _35, recompute_scale_factor0 = recompute_scale_factor1, recompute_scale_factor1
  else:
    _35, recompute_scale_factor0 = False, recompute_scale_factor
  if _35:
    recompute_scale_factor3 = unchecked_cast(bool, recompute_scale_factor0)
    _36, recompute_scale_factor2 = torch.__isnot__(size2, None), recompute_scale_factor3
  else:
    _36, recompute_scale_factor2 = False, recompute_scale_factor0
  if _36:
    ops.prim.RaiseException(_4, "builtins.ValueError")
    recompute_scale_factor4 : Optional[bool] = _17
  else:
    recompute_scale_factor4 = recompute_scale_factor2
  if torch.eq(mode, "area"):
    _37 = torch.__is__(output_size, None)
  else:
    _37 = False
  if _37:
    recompute_scale_factor5 : Optional[bool] = True
  else:
    recompute_scale_factor5 = recompute_scale_factor4
  _38 = torch.__isnot__(recompute_scale_factor5, None)
  if _38:
    recompute_scale_factor6 = unchecked_cast(bool, recompute_scale_factor5)
    _39 = recompute_scale_factor6
  else:
    _39 = False
  if _39:
    _40 = torch.__isnot__(scale_factors, None)
    if _40:
      scale_factors4 = unchecked_cast(List[float], scale_factors)
      scale_factors3 = scale_factors4
    else:
      ops.prim.RaiseException("AssertionError: ")
      scale_factors3 = _19
    output_size4 = annotate(List[int], [])
    for i in range(dim):
      _41 = torch.size(input, torch.add(i, 2))
      _42 = torch.mul(float(_41), scale_factors3[i])
      _43 = torch.append(output_size4, torch.floor(_42))
    output_size3, scale_factors2 = output_size4, None
  else:
    output_size3, scale_factors2 = output_size, scale_factors
  if antialias:
    _45 = torch.__contains__(["bilinear", "bicubic"], mode)
    if _45:
      _46 = torch.eq(torch.dim(input), 4)
    else:
      _46 = False
    _44 = torch.__not__(_46)
  else:
    _44 = False
  if _44:
    ops.prim.RaiseException(_5, "builtins.ValueError")
  else:
    pass
  if torch.eq(torch.dim(input), 3):
    _47 = torch.eq(mode, "nearest")
  else:
    _47 = False
  if _47:
    _49 = torch.upsample_nearest1d(input, output_size3, scale_factors2)
    _48 = _49
  else:
    if torch.eq(torch.dim(input), 4):
      _50 = torch.eq(mode, "nearest")
    else:
      _50 = False
    if _50:
      _52 = torch.upsample_nearest2d(input, output_size3, scale_factors2)
      _51 = _52
    else:
      if torch.eq(torch.dim(input), 5):
        _53 = torch.eq(mode, "nearest")
      else:
        _53 = False
      if _53:
        _55 = torch.upsample_nearest3d(input, output_size3, scale_factors2)
        _54 = _55
      else:
        if torch.eq(torch.dim(input), 3):
          _57 = torch.eq(mode, "nearest-exact")
          _56 = _57
        else:
          _56 = False
        if _56:
          _59 = torch._upsample_nearest_exact1d(input, output_size3, scale_factors2)
          _58 = _59
        else:
          if torch.eq(torch.dim(input), 4):
            _61 = torch.eq(mode, "nearest-exact")
            _60 = _61
          else:
            _60 = False
          if _60:
            _63 = torch._upsample_nearest_exact2d(input, output_size3, scale_factors2)
            _62 = _63
          else:
            _64 = torch.eq(torch.dim(input), 5)
            if _64:
              _66 = torch.eq(mode, "nearest-exact")
              _65 = _66
            else:
              _65 = False
            if _65:
              _68 = torch._upsample_nearest_exact3d(input, output_size3, scale_factors2)
              _67 = _68
            else:
              _69 = torch.eq(torch.dim(input), 3)
              if _69:
                _70 = torch.eq(mode, "area")
              else:
                _70 = False
              if _70:
                _72 = torch.__isnot__(output_size3, None)
                if _72:
                  output_size6 = unchecked_cast(List[int], output_size3)
                  output_size5 = output_size6
                else:
                  ops.prim.RaiseException("AssertionError: ")
                  output_size5 = _16
                _73 = torch.adaptive_avg_pool1d(input, output_size5)
                _71 = _73
              else:
                _74 = torch.eq(torch.dim(input), 4)
                if _74:
                  _76 = torch.eq(mode, "area")
                  _75 = _76
                else:
                  _75 = False
                if _75:
                  _78 = torch.__isnot__(output_size3, None)
                  if _78:
                    output_size8 = unchecked_cast(List[int], output_size3)
                    output_size7 = output_size8
                  else:
                    ops.prim.RaiseException("AssertionError: ")
                    output_size7 = _16
                  _79 = _6(input, output_size7, )
                  _77 = _79
                else:
                  _80 = torch.eq(torch.dim(input), 5)
                  if _80:
                    _82 = torch.eq(mode, "area")
                    _81 = _82
                  else:
                    _81 = False
                  if _81:
                    _84 = torch.__isnot__(output_size3, None)
                    if _84:
                      output_size10 = unchecked_cast(List[int], output_size3)
                      output_size9 = output_size10
                    else:
                      ops.prim.RaiseException("AssertionError: ")
                      output_size9 = _16
                    _85 = _7(input, output_size9, )
                    _83 = _85
                  else:
                    _86 = torch.eq(torch.dim(input), 3)
                    if _86:
                      _88 = torch.eq(mode, "linear")
                      _87 = _88
                    else:
                      _87 = False
                    if _87:
                      _90 = torch.__isnot__(align_corners0, None)
                      if _90:
                        align_corners5 = unchecked_cast(bool, align_corners0)
                        align_corners4 = align_corners5
                      else:
                        ops.prim.RaiseException("AssertionError: ")
                        align_corners4 = _24
                      _91 = torch.upsample_linear1d(input, output_size3, align_corners4, scale_factors2)
                      _89 = _91
                    else:
                      _92 = torch.eq(torch.dim(input), 4)
                      if _92:
                        _94 = torch.eq(mode, "bilinear")
                        _93 = _94
                      else:
                        _93 = False
                      if _93:
                        _96 = torch.__isnot__(align_corners0, None)
                        if _96:
                          align_corners7 = unchecked_cast(bool, align_corners0)
                          align_corners6 = align_corners7
                        else:
                          ops.prim.RaiseException("AssertionError: ")
                          align_corners6 = _24
                        if antialias:
                          _98 = torch._upsample_bilinear2d_aa(input, output_size3, align_corners6, scale_factors2)
                          _97 = _98
                        else:
                          _99 = torch.upsample_bilinear2d(input, output_size3, align_corners6, scale_factors2)
                          _97 = _99
                        _95 = _97
                      else:
                        _100 = torch.dim(input)
                        _101 = torch.eq(_100, 5)
                        if _101:
                          _103 = torch.eq(mode, "trilinear")
                          _102 = _103
                        else:
                          _102 = False
                        if _102:
                          _105 = torch.__isnot__(align_corners0, None)
                          if _105:
                            align_corners9 = unchecked_cast(bool, align_corners0)
                            align_corners8 = align_corners9
                          else:
                            ops.prim.RaiseException("AssertionError: ")
                            align_corners8 = _24
                          _106 = torch.upsample_trilinear3d(input, output_size3, align_corners8, scale_factors2)
                          _104 = _106
                        else:
                          _107 = torch.dim(input)
                          _108 = torch.eq(_107, 4)
                          if _108:
                            _110 = torch.eq(mode, "bicubic")
                            _109 = _110
                          else:
                            _109 = False
                          if _109:
                            _112 = torch.__isnot__(align_corners0, None)
                            if _112:
                              align_corners11 = unchecked_cast(bool, align_corners0)
                              align_corners10 = align_corners11
                            else:
                              ops.prim.RaiseException("AssertionError: ")
                              align_corners10 = _24
                            if antialias:
                              _114 = torch._upsample_bicubic2d_aa(input, output_size3, align_corners10, scale_factors2)
                              _113 = _114
                            else:
                              _115 = torch.upsample_bicubic2d(input, output_size3, align_corners10, scale_factors2)
                              _113 = _115
                            _111 = _113
                          else:
                            _116 = torch.dim(input)
                            _117 = torch.eq(_116, 3)
                            if _117:
                              _119 = torch.eq(mode, "bilinear")
                              _118 = _119
                            else:
                              _118 = False
                            if _118:
                              ops.prim.RaiseException(_8, "builtins.NotImplementedError")
                            else:
                              pass
                            _120 = torch.dim(input)
                            _121 = torch.eq(_120, 3)
                            if _121:
                              _123 = torch.eq(mode, "trilinear")
                              _122 = _123
                            else:
                              _122 = False
                            if _122:
                              ops.prim.RaiseException(_9, "builtins.NotImplementedError")
                            else:
                              pass
                            _124 = torch.dim(input)
                            _125 = torch.eq(_124, 4)
                            if _125:
                              _127 = torch.eq(mode, "linear")
                              _126 = _127
                            else:
                              _126 = False
                            if _126:
                              ops.prim.RaiseException(_10, "builtins.NotImplementedError")
                            else:
                              pass
                            _128 = torch.dim(input)
                            _129 = torch.eq(_128, 4)
                            if _129:
                              _131 = torch.eq(mode, "trilinear")
                              _130 = _131
                            else:
                              _130 = False
                            if _130:
                              ops.prim.RaiseException(_11, "builtins.NotImplementedError")
                            else:
                              pass
                            _132 = torch.dim(input)
                            _133 = torch.eq(_132, 5)
                            if _133:
                              _135 = torch.eq(mode, "linear")
                              _134 = _135
                            else:
                              _134 = False
                            if _134:
                              ops.prim.RaiseException(_12, "builtins.NotImplementedError")
                            else:
                              pass
                            _136 = torch.dim(input)
                            _137 = torch.eq(_136, 5)
                            if _137:
                              _139 = torch.eq(mode, "bilinear")
                              _138 = _139
                            else:
                              _138 = False
                            if _138:
                              ops.prim.RaiseException(_13, "builtins.NotImplementedError")
                            else:
                              pass
                            _140 = torch.dim(input)
                            _141 = torch.format(_14, _140, mode)
                            ops.prim.RaiseException(_141, "builtins.NotImplementedError")
                            _111 = _15
                          _104 = _111
                        _95 = _104
                      _89 = _95
                    _83 = _89
                  _77 = _83
                _71 = _77
              _67 = _71
            _62 = _67
          _58 = _62
        _54 = _58
      _51 = _54
    _48 = _51
  return _48
def adaptive_avg_pool2d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _142 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _142:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _143 = torch.adaptive_avg_pool2d(input, output_size)
  return _143
def adaptive_avg_pool3d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _144 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _144:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _145 = torch.adaptive_avg_pool3d(input, output_size)
  return _145
